/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.adaptation.impl;

import edu.kit.ipd.descartes.mm.adaptation.AdaptationPackage;
import edu.kit.ipd.descartes.mm.adaptation.RelationalOperator;
import edu.kit.ipd.descartes.mm.adaptation.Specification;

import edu.kit.ipd.descartes.perfdatarepo.MetricType;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Specification</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl#getMetricType <em>Metric Type</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl#getValue <em>Value</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.adaptation.impl.SpecificationImpl#getRelationalOperator <em>Relational Operator</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class SpecificationImpl extends EObjectImpl implements Specification {
    /**
	 * The cached value of the '{@link #getMetricType() <em>Metric Type</em>}' reference.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getMetricType()
	 * @generated
	 * @ordered
	 */
    protected MetricType metricType;

    /**
	 * The default value of the '{@link #getValue() <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
    protected static final double VALUE_EDEFAULT = 0.0;

    /**
	 * The cached value of the '{@link #getValue() <em>Value</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getValue()
	 * @generated
	 * @ordered
	 */
    protected double value = VALUE_EDEFAULT;

    /**
	 * The default value of the '{@link #getRelationalOperator() <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getRelationalOperator()
	 * @generated
	 * @ordered
	 */
    protected static final RelationalOperator RELATIONAL_OPERATOR_EDEFAULT = RelationalOperator.EQUAL;

    /**
	 * The cached value of the '{@link #getRelationalOperator() <em>Relational Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @see #getRelationalOperator()
	 * @generated
	 * @ordered
	 */
    protected RelationalOperator relationalOperator = RELATIONAL_OPERATOR_EDEFAULT;

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    protected SpecificationImpl() {
		super();
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    protected EClass eStaticClass() {
		return AdaptationPackage.Literals.SPECIFICATION;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public MetricType getMetricType() {
		if (metricType != null && metricType.eIsProxy()) {
			InternalEObject oldMetricType = (InternalEObject)metricType;
			metricType = (MetricType)eResolveProxy(oldMetricType);
			if (metricType != oldMetricType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, AdaptationPackage.SPECIFICATION__METRIC_TYPE, oldMetricType, metricType));
			}
		}
		return metricType;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public MetricType basicGetMetricType() {
		return metricType;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setMetricType(MetricType newMetricType) {
		MetricType oldMetricType = metricType;
		metricType = newMetricType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.SPECIFICATION__METRIC_TYPE, oldMetricType, metricType));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public double getValue() {
		return value;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setValue(double newValue) {
		double oldValue = value;
		value = newValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.SPECIFICATION__VALUE, oldValue, value));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public RelationalOperator getRelationalOperator() {
		return relationalOperator;
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    public void setRelationalOperator(RelationalOperator newRelationalOperator) {
		RelationalOperator oldRelationalOperator = relationalOperator;
		relationalOperator = newRelationalOperator == null ? RELATIONAL_OPERATOR_EDEFAULT : newRelationalOperator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, AdaptationPackage.SPECIFICATION__RELATIONAL_OPERATOR, oldRelationalOperator, relationalOperator));
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case AdaptationPackage.SPECIFICATION__METRIC_TYPE:
				if (resolve) return getMetricType();
				return basicGetMetricType();
			case AdaptationPackage.SPECIFICATION__VALUE:
				return getValue();
			case AdaptationPackage.SPECIFICATION__RELATIONAL_OPERATOR:
				return getRelationalOperator();
		}
		return super.eGet(featureID, resolve, coreType);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case AdaptationPackage.SPECIFICATION__METRIC_TYPE:
				setMetricType((MetricType)newValue);
				return;
			case AdaptationPackage.SPECIFICATION__VALUE:
				setValue((Double)newValue);
				return;
			case AdaptationPackage.SPECIFICATION__RELATIONAL_OPERATOR:
				setRelationalOperator((RelationalOperator)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public void eUnset(int featureID) {
		switch (featureID) {
			case AdaptationPackage.SPECIFICATION__METRIC_TYPE:
				setMetricType((MetricType)null);
				return;
			case AdaptationPackage.SPECIFICATION__VALUE:
				setValue(VALUE_EDEFAULT);
				return;
			case AdaptationPackage.SPECIFICATION__RELATIONAL_OPERATOR:
				setRelationalOperator(RELATIONAL_OPERATOR_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public boolean eIsSet(int featureID) {
		switch (featureID) {
			case AdaptationPackage.SPECIFICATION__METRIC_TYPE:
				return metricType != null;
			case AdaptationPackage.SPECIFICATION__VALUE:
				return value != VALUE_EDEFAULT;
			case AdaptationPackage.SPECIFICATION__RELATIONAL_OPERATOR:
				return relationalOperator != RELATIONAL_OPERATOR_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

    /**
	 * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
	 * @generated
	 */
    @Override
    public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (value: ");
		result.append(value);
		result.append(", relationalOperator: ");
		result.append(relationalOperator);
		result.append(')');
		return result.toString();
	}

} //SpecificationImpl
