/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Dependency Propagation Relationship</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getIndependent <em>Independent</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getDependent <em>Dependent</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getIndependentComponentInstanceReferences <em>Independent Component Instance References</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getDependentComponentInstanceReference <em>Dependent Component Instance Reference</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyPropagationRelationship()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences DelegationOnlyAllowedWithSingleSource'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot NumberOfIndependentInfluencingParametersEqualToIndependentComponentInstanceReferences='\n\t\t\tindependent->size() = independentComponentInstanceReferences->size()' DelegationOnlyAllowedWithSingleSource='\n\t\t\tself.characterization = RelationshipCharacterizationType::IDENTITY implies independent->size() = 1'"
 * @generated
 */
public interface DependencyPropagationRelationship extends Relationship {
	/**
	 * Returns the value of the '<em><b>Independent</b></em>' reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.InfluencingParameter}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Independent</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Independent</em>' reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyPropagationRelationship_Independent()
	 * @model required="true"
	 * @generated
	 */
	EList<InfluencingParameter> getIndependent();

	/**
	 * Returns the value of the '<em><b>Dependent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependent</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependent</em>' reference.
	 * @see #setDependent(InfluencingParameter)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyPropagationRelationship_Dependent()
	 * @model required="true"
	 * @generated
	 */
	InfluencingParameter getDependent();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getDependent <em>Dependent</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dependent</em>' reference.
	 * @see #getDependent()
	 * @generated
	 */
	void setDependent(InfluencingParameter value);

	/**
	 * Returns the value of the '<em><b>Independent Component Instance References</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ComponentInstanceReference}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Independent Component Instance References</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Independent Component Instance References</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyPropagationRelationship_IndependentComponentInstanceReferences()
	 * @model containment="true" required="true"
	 * @generated
	 */
	EList<ComponentInstanceReference> getIndependentComponentInstanceReferences();

	/**
	 * Returns the value of the '<em><b>Dependent Component Instance Reference</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dependent Component Instance Reference</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Dependent Component Instance Reference</em>' containment reference.
	 * @see #setDependentComponentInstanceReference(ComponentInstanceReference)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage#getDependencyPropagationRelationship_DependentComponentInstanceReference()
	 * @model containment="true" required="true"
	 * @generated
	 */
	ComponentInstanceReference getDependentComponentInstanceReference();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.DependencyPropagationRelationship#getDependentComponentInstanceReference <em>Dependent Component Instance Reference</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Dependent Component Instance Reference</em>' containment reference.
	 * @see #getDependentComponentInstanceReference()
	 * @generated
	 */
	void setDependentComponentInstanceReference(ComponentInstanceReference value);

} // DependencyPropagationRelationship
