/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository.impl;

import edu.kit.ipd.descartes.core.impl.ConnectorImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyConnector;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.AssemblyContext;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.ComposedStructure;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceRequiringRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Assembly Connector</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyConnectorImpl#getParentStructure <em>Parent Structure</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyConnectorImpl#getInterfaceRequiringRole <em>Interface Requiring Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyConnectorImpl#getInterfaceProvidingRole <em>Interface Providing Role</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyConnectorImpl#getProvidingAssemblyContext <em>Providing Assembly Context</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.AssemblyConnectorImpl#getRequiringAssemblyContext <em>Requiring Assembly Context</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class AssemblyConnectorImpl extends ConnectorImpl implements AssemblyConnector {
	/**
	 * The cached value of the '{@link #getInterfaceRequiringRole() <em>Interface Requiring Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceRequiringRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceRequiringRole interfaceRequiringRole;

	/**
	 * The cached value of the '{@link #getInterfaceProvidingRole() <em>Interface Providing Role</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceProvidingRole()
	 * @generated
	 * @ordered
	 */
	protected InterfaceProvidingRole interfaceProvidingRole;

	/**
	 * The cached value of the '{@link #getProvidingAssemblyContext() <em>Providing Assembly Context</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProvidingAssemblyContext()
	 * @generated
	 * @ordered
	 */
	protected AssemblyContext providingAssemblyContext;

	/**
	 * The cached value of the '{@link #getRequiringAssemblyContext() <em>Requiring Assembly Context</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRequiringAssemblyContext()
	 * @generated
	 * @ordered
	 */
	protected AssemblyContext requiringAssemblyContext;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AssemblyConnectorImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.ASSEMBLY_CONNECTOR;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposedStructure getParentStructure() {
		if (eContainerFeatureID() != RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE) return null;
		return (ComposedStructure)eInternalContainer();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetParentStructure(ComposedStructure newParentStructure, NotificationChain msgs) {
		msgs = eBasicSetContainer((InternalEObject)newParentStructure, RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE, msgs);
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentStructure(ComposedStructure newParentStructure) {
		if (newParentStructure != eInternalContainer() || (eContainerFeatureID() != RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE && newParentStructure != null)) {
			if (EcoreUtil.isAncestor(this, newParentStructure))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
			NotificationChain msgs = null;
			if (eInternalContainer() != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newParentStructure != null)
				msgs = ((InternalEObject)newParentStructure).eInverseAdd(this, RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS, ComposedStructure.class, msgs);
			msgs = basicSetParentStructure(newParentStructure, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE, newParentStructure, newParentStructure));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole getInterfaceRequiringRole() {
		if (interfaceRequiringRole != null && interfaceRequiringRole.eIsProxy()) {
			InternalEObject oldInterfaceRequiringRole = (InternalEObject)interfaceRequiringRole;
			interfaceRequiringRole = (InterfaceRequiringRole)eResolveProxy(oldInterfaceRequiringRole);
			if (interfaceRequiringRole != oldInterfaceRequiringRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE, oldInterfaceRequiringRole, interfaceRequiringRole));
			}
		}
		return interfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceRequiringRole basicGetInterfaceRequiringRole() {
		return interfaceRequiringRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterfaceRequiringRole(InterfaceRequiringRole newInterfaceRequiringRole) {
		InterfaceRequiringRole oldInterfaceRequiringRole = interfaceRequiringRole;
		interfaceRequiringRole = newInterfaceRequiringRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE, oldInterfaceRequiringRole, interfaceRequiringRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole getInterfaceProvidingRole() {
		if (interfaceProvidingRole != null && interfaceProvidingRole.eIsProxy()) {
			InternalEObject oldInterfaceProvidingRole = (InternalEObject)interfaceProvidingRole;
			interfaceProvidingRole = (InterfaceProvidingRole)eResolveProxy(oldInterfaceProvidingRole);
			if (interfaceProvidingRole != oldInterfaceProvidingRole) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE, oldInterfaceProvidingRole, interfaceProvidingRole));
			}
		}
		return interfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InterfaceProvidingRole basicGetInterfaceProvidingRole() {
		return interfaceProvidingRole;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInterfaceProvidingRole(InterfaceProvidingRole newInterfaceProvidingRole) {
		InterfaceProvidingRole oldInterfaceProvidingRole = interfaceProvidingRole;
		interfaceProvidingRole = newInterfaceProvidingRole;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE, oldInterfaceProvidingRole, interfaceProvidingRole));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AssemblyContext getProvidingAssemblyContext() {
		if (providingAssemblyContext != null && providingAssemblyContext.eIsProxy()) {
			InternalEObject oldProvidingAssemblyContext = (InternalEObject)providingAssemblyContext;
			providingAssemblyContext = (AssemblyContext)eResolveProxy(oldProvidingAssemblyContext);
			if (providingAssemblyContext != oldProvidingAssemblyContext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT, oldProvidingAssemblyContext, providingAssemblyContext));
			}
		}
		return providingAssemblyContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AssemblyContext basicGetProvidingAssemblyContext() {
		return providingAssemblyContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setProvidingAssemblyContext(AssemblyContext newProvidingAssemblyContext) {
		AssemblyContext oldProvidingAssemblyContext = providingAssemblyContext;
		providingAssemblyContext = newProvidingAssemblyContext;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT, oldProvidingAssemblyContext, providingAssemblyContext));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AssemblyContext getRequiringAssemblyContext() {
		if (requiringAssemblyContext != null && requiringAssemblyContext.eIsProxy()) {
			InternalEObject oldRequiringAssemblyContext = (InternalEObject)requiringAssemblyContext;
			requiringAssemblyContext = (AssemblyContext)eResolveProxy(oldRequiringAssemblyContext);
			if (requiringAssemblyContext != oldRequiringAssemblyContext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT, oldRequiringAssemblyContext, requiringAssemblyContext));
			}
		}
		return requiringAssemblyContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AssemblyContext basicGetRequiringAssemblyContext() {
		return requiringAssemblyContext;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRequiringAssemblyContext(AssemblyContext newRequiringAssemblyContext) {
		AssemblyContext oldRequiringAssemblyContext = requiringAssemblyContext;
		requiringAssemblyContext = newRequiringAssemblyContext;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT, oldRequiringAssemblyContext, requiringAssemblyContext));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				if (eInternalContainer() != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return basicSetParentStructure((ComposedStructure)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				return basicSetParentStructure(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
		switch (eContainerFeatureID()) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				return eInternalContainer().eInverseRemove(this, RepositoryPackage.COMPOSED_STRUCTURE__ASSEMBLY_CONNECTORS, ComposedStructure.class, msgs);
		}
		return super.eBasicRemoveFromContainerFeature(msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				return getParentStructure();
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE:
				if (resolve) return getInterfaceRequiringRole();
				return basicGetInterfaceRequiringRole();
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE:
				if (resolve) return getInterfaceProvidingRole();
				return basicGetInterfaceProvidingRole();
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT:
				if (resolve) return getProvidingAssemblyContext();
				return basicGetProvidingAssemblyContext();
			case RepositoryPackage.ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT:
				if (resolve) return getRequiringAssemblyContext();
				return basicGetRequiringAssemblyContext();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)newValue);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE:
				setInterfaceRequiringRole((InterfaceRequiringRole)newValue);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE:
				setInterfaceProvidingRole((InterfaceProvidingRole)newValue);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT:
				setProvidingAssemblyContext((AssemblyContext)newValue);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT:
				setRequiringAssemblyContext((AssemblyContext)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				setParentStructure((ComposedStructure)null);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE:
				setInterfaceRequiringRole((InterfaceRequiringRole)null);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE:
				setInterfaceProvidingRole((InterfaceProvidingRole)null);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT:
				setProvidingAssemblyContext((AssemblyContext)null);
				return;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT:
				setRequiringAssemblyContext((AssemblyContext)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PARENT_STRUCTURE:
				return getParentStructure() != null;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_REQUIRING_ROLE:
				return interfaceRequiringRole != null;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__INTERFACE_PROVIDING_ROLE:
				return interfaceProvidingRole != null;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__PROVIDING_ASSEMBLY_CONTEXT:
				return providingAssemblyContext != null;
			case RepositoryPackage.ASSEMBLY_CONNECTOR__REQUIRING_ASSEMBLY_CONTEXT:
				return requiringAssemblyContext != null;
		}
		return super.eIsSet(featureID);
	}

} //AssemblyConnectorImpl
