/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.repository.impl;

import edu.kit.ipd.descartes.core.impl.EntityImpl;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingEntity;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRole;
import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.BlackBoxBehavior;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interface Providing Entity</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.InterfaceProvidingEntityImpl#getInterfaceProvidingRoles <em>Interface Providing Roles</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.repository.impl.InterfaceProvidingEntityImpl#getBlackBoxBehavior <em>Black Box Behavior</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public abstract class InterfaceProvidingEntityImpl extends EntityImpl implements InterfaceProvidingEntity {
	/**
	 * The cached value of the '{@link #getInterfaceProvidingRoles() <em>Interface Providing Roles</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getInterfaceProvidingRoles()
	 * @generated
	 * @ordered
	 */
	protected EList<InterfaceProvidingRole> interfaceProvidingRoles;

	/**
	 * The cached value of the '{@link #getBlackBoxBehavior() <em>Black Box Behavior</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getBlackBoxBehavior()
	 * @generated
	 * @ordered
	 */
	protected EList<BlackBoxBehavior> blackBoxBehavior;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InterfaceProvidingEntityImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.INTERFACE_PROVIDING_ENTITY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<InterfaceProvidingRole> getInterfaceProvidingRoles() {
		if (interfaceProvidingRoles == null) {
			interfaceProvidingRoles = new EObjectContainmentWithInverseEList<InterfaceProvidingRole>(InterfaceProvidingRole.class, this, RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES, RepositoryPackage.INTERFACE_PROVIDING_ROLE__INTERFACE_PROVIDING_ENTITY);
		}
		return interfaceProvidingRoles;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<BlackBoxBehavior> getBlackBoxBehavior() {
		if (blackBoxBehavior == null) {
			blackBoxBehavior = new EObjectContainmentEList<BlackBoxBehavior>(BlackBoxBehavior.class, this, RepositoryPackage.INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR);
		}
		return blackBoxBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getInterfaceProvidingRoles()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES:
				return ((InternalEList<?>)getInterfaceProvidingRoles()).basicRemove(otherEnd, msgs);
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR:
				return ((InternalEList<?>)getBlackBoxBehavior()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES:
				return getInterfaceProvidingRoles();
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR:
				return getBlackBoxBehavior();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES:
				getInterfaceProvidingRoles().clear();
				getInterfaceProvidingRoles().addAll((Collection<? extends InterfaceProvidingRole>)newValue);
				return;
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR:
				getBlackBoxBehavior().clear();
				getBlackBoxBehavior().addAll((Collection<? extends BlackBoxBehavior>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES:
				getInterfaceProvidingRoles().clear();
				return;
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR:
				getBlackBoxBehavior().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__INTERFACE_PROVIDING_ROLES:
				return interfaceProvidingRoles != null && !interfaceProvidingRoles.isEmpty();
			case RepositoryPackage.INTERFACE_PROVIDING_ENTITY__BLACK_BOX_BEHAVIOR:
				return blackBoxBehavior != null && !blackBoxBehavior.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //InterfaceProvidingEntityImpl
