/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.InterfaceProvidingRequiringEntity;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Coarse Grained Behavior</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * --# TODO discuss this construction of InternalCallAction and InternalHelper(Container)
 * class InternalCallAction {
 * property internalFineGrainedBehaviorHelper : InternalFineGrainedBehaviorHelper[1];
 * }
 * class InternalFineGrainedBehaviorHelper extends core_0::Entity {
 * invariant parametersMustHaveUniqueNames: self.parameters->isUnique(p : repository_0::Parameter | p.name);
 * property parameters : repository_0::Parameter[0..*] { composes };
 * property returnType : repository_0::DataType[0..1];
 * property internalFineGrainedBehaviorHelperContainer#internalFineGrainedBehaviorHelper : InternalFineGrainedBehaviorHelperContainer[1];
 * property behavior : ComponentInternalBehavior[1] { composes };
 * }
 * class InternalFineGrainedBehaviorHelperContainer extends core_0::Entity {
 * invariant internalFineGrainedBehaviorHelperMustBeUnique:
 * let helper : Bag(
 * -- parameters: Sequence of DataType, NOT name
 * -- return types have not to be considered
 * -- exceptions have not to be considered
 * Tuple(helperName : String, parameters : Sequence(repository_0::DataType) )
 * ) = self.internalFineGrainedBehaviorHelper->collect(h : InternalFineGrainedBehaviorHelper | Tuple{
 * helperName : String = h.name,
 * parameters : Sequence(repository_0::DataType) = h.parameters.dataType }
 * ) in helper->isUnique(h|h);
 * property internalFineGrainedBehaviorHelper#internalFineGrainedBehaviorHelperContainer : InternalFineGrainedBehaviorHelper[0..*] { composes };
 * property component#internalFineGrainedBehaviorHelperContainer : repository_0::BasicComponent[1];
 * }
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior#getDescribedEntity <em>Described Entity</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior#getExternalCallFrequency <em>External Call Frequency</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior#getResourceDemand <em>Resource Demand</em>}</li>
 * </ul>
 * </p>
 *
 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getCoarseGrainedBehavior()
 * @model annotation="http://www.eclipse.org/emf/2002/Ecore constraints='AtMostOneCoarseGrainedBehaviorPerProvidedService'"
 *        annotation="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot AtMostOneCoarseGrainedBehaviorPerProvidedService='\n\t\t\tself.describedEntity.coarseGrainedBehavior->forAll(cgb1 : CoarseGrainedBehavior | cgb1.describedSignature = self.describedSignature implies cgb1 = self)'"
 * @generated
 */
public interface CoarseGrainedBehavior extends ServiceBehaviorAbstraction {
	/**
	 * Returns the value of the '<em><b>Described Entity</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Described Entity</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Described Entity</em>' reference.
	 * @see #setDescribedEntity(InterfaceProvidingRequiringEntity)
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getCoarseGrainedBehavior_DescribedEntity()
	 * @model required="true"
	 * @generated
	 */
	InterfaceProvidingRequiringEntity getDescribedEntity();

	/**
	 * Sets the value of the '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.CoarseGrainedBehavior#getDescribedEntity <em>Described Entity</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Described Entity</em>' reference.
	 * @see #getDescribedEntity()
	 * @generated
	 */
	void setDescribedEntity(InterfaceProvidingRequiringEntity value);

	/**
	 * Returns the value of the '<em><b>External Call Frequency</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCallFrequency}.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCallFrequency#getCoarseGrainedBehavior <em>Coarse Grained Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>External Call Frequency</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>External Call Frequency</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getCoarseGrainedBehavior_ExternalCallFrequency()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ExternalCallFrequency#getCoarseGrainedBehavior
	 * @model opposite="coarseGrainedBehavior" containment="true" ordered="false"
	 * @generated
	 */
	EList<ExternalCallFrequency> getExternalCallFrequency();

	/**
	 * Returns the value of the '<em><b>Resource Demand</b></em>' containment reference list.
	 * The list contents are of type {@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand}.
	 * It is bidirectional and its opposite is '{@link edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand#getCoarseGrainedBehavior <em>Coarse Grained Behavior</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Resource Demand</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource Demand</em>' containment reference list.
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage#getCoarseGrainedBehavior_ResourceDemand()
	 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ResourceDemand#getCoarseGrainedBehavior
	 * @model opposite="coarseGrainedBehavior" containment="true" ordered="false"
	 * @generated
	 */
	EList<ResourceDemand> getResourceDemand();

} // CoarseGrainedBehavior
