/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.util;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.util.ParameterdependenciesValidator;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.*;

import java.util.Map;

import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * @see edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage
 * @generated
 */
public class ServicebehaviorValidator extends EObjectValidator {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final ServicebehaviorValidator INSTANCE = new ServicebehaviorValidator();

	/**
	 * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.common.util.Diagnostic#getSource()
	 * @see org.eclipse.emf.common.util.Diagnostic#getCode()
	 * @generated
	 */
	public static final String DIAGNOSTIC_SOURCE = "edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior";

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 0;

	/**
	 * A constant with a fixed name that can be used as the base value for additional hand written constants in a derived class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

	/**
	 * The cached base package validator.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ParameterdependenciesValidator parameterdependenciesValidator;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ServicebehaviorValidator() {
		super();
		parameterdependenciesValidator = ParameterdependenciesValidator.INSTANCE;
	}

	/**
	 * Returns the package of this validator switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EPackage getEPackage() {
	  return ServicebehaviorPackage.eINSTANCE;
	}

	/**
	 * Calls <code>validateXXX</code> for the corresponding classifier of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected boolean validate(int classifierID, Object value, DiagnosticChain diagnostics, Map<Object, Object> context) {
		switch (classifierID) {
			case ServicebehaviorPackage.SERVICE_BEHAVIOR_ABSTRACTION:
				return validateServiceBehaviorAbstraction((ServiceBehaviorAbstraction)value, diagnostics, context);
			case ServicebehaviorPackage.FINE_GRAINED_BEHAVIOR:
				return validateFineGrainedBehavior((FineGrainedBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.COMPONENT_INTERNAL_BEHAVIOR:
				return validateComponentInternalBehavior((ComponentInternalBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.ABSTRACT_ACTION:
				return validateAbstractAction((AbstractAction)value, diagnostics, context);
			case ServicebehaviorPackage.ACQUIRE_ACTION:
				return validateAcquireAction((AcquireAction)value, diagnostics, context);
			case ServicebehaviorPackage.RELEASE_ACTION:
				return validateReleaseAction((ReleaseAction)value, diagnostics, context);
			case ServicebehaviorPackage.INTERNAL_ACTION:
				return validateInternalAction((InternalAction)value, diagnostics, context);
			case ServicebehaviorPackage.FORK_ACTION:
				return validateForkAction((ForkAction)value, diagnostics, context);
			case ServicebehaviorPackage.BRANCH_ACTION:
				return validateBranchAction((BranchAction)value, diagnostics, context);
			case ServicebehaviorPackage.BRANCH_PROBABILITIES:
				return validateBranchProbabilities((BranchProbabilities)value, diagnostics, context);
			case ServicebehaviorPackage.LOOP_ACTION:
				return validateLoopAction((LoopAction)value, diagnostics, context);
			case ServicebehaviorPackage.LOOP_ITERATION_COUNT:
				return validateLoopIterationCount((LoopIterationCount)value, diagnostics, context);
			case ServicebehaviorPackage.EXTERNAL_CALL_ACTION:
				return validateExternalCallAction((ExternalCallAction)value, diagnostics, context);
			case ServicebehaviorPackage.EXTERNAL_CALL:
				return validateExternalCall((ExternalCall)value, diagnostics, context);
			case ServicebehaviorPackage.RESOURCE_DEMAND:
				return validateResourceDemand((ResourceDemand)value, diagnostics, context);
			case ServicebehaviorPackage.COARSE_GRAINED_BEHAVIOR:
				return validateCoarseGrainedBehavior((CoarseGrainedBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.EXTERNAL_CALL_FREQUENCY:
				return validateExternalCallFrequency((ExternalCallFrequency)value, diagnostics, context);
			case ServicebehaviorPackage.CALL_FREQUENCY:
				return validateCallFrequency((CallFrequency)value, diagnostics, context);
			case ServicebehaviorPackage.BLACK_BOX_BEHAVIOR:
				return validateBlackBoxBehavior((BlackBoxBehavior)value, diagnostics, context);
			case ServicebehaviorPackage.RESPONSE_TIME:
				return validateResponseTime((ResponseTime)value, diagnostics, context);
			default:
				return true;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceBehaviorAbstraction(ServiceBehaviorAbstraction serviceBehaviorAbstraction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(serviceBehaviorAbstraction, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(serviceBehaviorAbstraction, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_InfluencingParameterNamesMustBeUnique(serviceBehaviorAbstraction, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole constraint of '<em>Service Behavior Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE_MUST_BELONG_TO_INTERFACE_REFERENCED_BY_INTERFACE_PROVIDING_ROLE__EEXPRESSION = "\n" +
		"\t\t\tself.interfaceProvidingRole.interface.signatures->exists(sign|sign=self.describedSignature)";

	/**
	 * Validates the DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole constraint of '<em>Service Behavior Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(ServiceBehaviorAbstraction serviceBehaviorAbstraction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.SERVICE_BEHAVIOR_ABSTRACTION,
				 serviceBehaviorAbstraction,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole",
				 SERVICE_BEHAVIOR_ABSTRACTION__DESCRIBED_SIGNATURE_MUST_BELONG_TO_INTERFACE_REFERENCED_BY_INTERFACE_PROVIDING_ROLE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * The cached validation expression for the InfluencingParameterNamesMustBeUnique constraint of '<em>Service Behavior Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER_NAMES_MUST_BE_UNIQUE__EEXPRESSION = "\n" +
		"\t\t\tself.influencingParameter->select(inflp | inflp.oclIsKindOf(parameterdependencies::ShadowParameter))\n" +
		"\t\t\t\t\t\t\t\t\t ->collect(inflp | inflp.oclAsType(parameterdependencies::ShadowParameter))\n" +
		"\t\t\t\t\t\t\t\t\t ->isUnique(inflp | inflp.name)";

	/**
	 * Validates the InfluencingParameterNamesMustBeUnique constraint of '<em>Service Behavior Abstraction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateServiceBehaviorAbstraction_InfluencingParameterNamesMustBeUnique(ServiceBehaviorAbstraction serviceBehaviorAbstraction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.SERVICE_BEHAVIOR_ABSTRACTION,
				 serviceBehaviorAbstraction,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "InfluencingParameterNamesMustBeUnique",
				 SERVICE_BEHAVIOR_ABSTRACTION__INFLUENCING_PARAMETER_NAMES_MUST_BE_UNIQUE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateFineGrainedBehavior(FineGrainedBehavior fineGrainedBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(fineGrainedBehavior, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(fineGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_InfluencingParameterNamesMustBeUnique(fineGrainedBehavior, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateComponentInternalBehavior(ComponentInternalBehavior componentInternalBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(componentInternalBehavior, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAbstractAction(AbstractAction abstractAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(abstractAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateAcquireAction(AcquireAction acquireAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(acquireAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateReleaseAction(ReleaseAction releaseAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(releaseAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateInternalAction(InternalAction internalAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(internalAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateForkAction(ForkAction forkAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(forkAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBranchAction(BranchAction branchAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(branchAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBranchProbabilities(BranchProbabilities branchProbabilities, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(branchProbabilities, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(branchProbabilities, diagnostics, context);
		if (result || diagnostics != null) result &= parameterdependenciesValidator.validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(branchProbabilities, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLoopAction(LoopAction loopAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(loopAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateLoopIterationCount(LoopIterationCount loopIterationCount, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(loopIterationCount, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(loopIterationCount, diagnostics, context);
		if (result || diagnostics != null) result &= parameterdependenciesValidator.validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(loopIterationCount, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallAction(ExternalCallAction externalCallAction, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(externalCallAction, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCall(ExternalCall externalCall, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(externalCall, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(externalCall, diagnostics, context);
		if (result || diagnostics != null) result &= validateExternalCall_SignatureBelongsToInterfaceRequiringRole(externalCall, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the SignatureBelongsToInterfaceRequiringRole constraint of '<em>External Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String EXTERNAL_CALL__SIGNATURE_BELONGS_TO_INTERFACE_REQUIRING_ROLE__EEXPRESSION = "\n" +
		"\t\t\tself.interfaceRequiringRole.interface.signatures->includes(self.signature)";

	/**
	 * Validates the SignatureBelongsToInterfaceRequiringRole constraint of '<em>External Call</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCall_SignatureBelongsToInterfaceRequiringRole(ExternalCall externalCall, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.EXTERNAL_CALL,
				 externalCall,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "SignatureBelongsToInterfaceRequiringRole",
				 EXTERNAL_CALL__SIGNATURE_BELONGS_TO_INTERFACE_REQUIRING_ROLE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResourceDemand(ResourceDemand resourceDemand, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(resourceDemand, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(resourceDemand, diagnostics, context);
		if (result || diagnostics != null) result &= validateResourceDemand_EnforceExplicitDescriptionWhenExplicitCharacterizationType(resourceDemand, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Resource Demand</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String RESOURCE_DEMAND__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION = "\n" +
		"\t\t   self.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null";

	/**
	 * Validates the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Resource Demand</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResourceDemand_EnforceExplicitDescriptionWhenExplicitCharacterizationType(ResourceDemand resourceDemand, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.RESOURCE_DEMAND,
				 resourceDemand,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EnforceExplicitDescriptionWhenExplicitCharacterizationType",
				 RESOURCE_DEMAND__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCoarseGrainedBehavior(CoarseGrainedBehavior coarseGrainedBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(coarseGrainedBehavior, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_InfluencingParameterNamesMustBeUnique(coarseGrainedBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateCoarseGrainedBehavior_AtMostOneCoarseGrainedBehaviorPerProvidedService(coarseGrainedBehavior, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the AtMostOneCoarseGrainedBehaviorPerProvidedService constraint of '<em>Coarse Grained Behavior</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String COARSE_GRAINED_BEHAVIOR__AT_MOST_ONE_COARSE_GRAINED_BEHAVIOR_PER_PROVIDED_SERVICE__EEXPRESSION = "\n" +
		"\t\t\tself.describedEntity.coarseGrainedBehavior->forAll(cgb1 : CoarseGrainedBehavior | cgb1.describedSignature = self.describedSignature implies cgb1 = self)";

	/**
	 * Validates the AtMostOneCoarseGrainedBehaviorPerProvidedService constraint of '<em>Coarse Grained Behavior</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCoarseGrainedBehavior_AtMostOneCoarseGrainedBehaviorPerProvidedService(CoarseGrainedBehavior coarseGrainedBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.COARSE_GRAINED_BEHAVIOR,
				 coarseGrainedBehavior,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "AtMostOneCoarseGrainedBehaviorPerProvidedService",
				 COARSE_GRAINED_BEHAVIOR__AT_MOST_ONE_COARSE_GRAINED_BEHAVIOR_PER_PROVIDED_SERVICE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateExternalCallFrequency(ExternalCallFrequency externalCallFrequency, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return validate_EveryDefaultConstraint(externalCallFrequency, diagnostics, context);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateCallFrequency(CallFrequency callFrequency, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(callFrequency, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(callFrequency, diagnostics, context);
		if (result || diagnostics != null) result &= parameterdependenciesValidator.validateControlFlowVariable_EnforceExplicitDescriptionWhenExplicitCharacterizationType(callFrequency, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateBlackBoxBehavior(BlackBoxBehavior blackBoxBehavior, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(blackBoxBehavior, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_DescribedSignatureMustBelongToInterfaceReferencedByInterfaceProvidingRole(blackBoxBehavior, diagnostics, context);
		if (result || diagnostics != null) result &= validateServiceBehaviorAbstraction_InfluencingParameterNamesMustBeUnique(blackBoxBehavior, diagnostics, context);
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResponseTime(ResponseTime responseTime, DiagnosticChain diagnostics, Map<Object, Object> context) {
		if (!validate_NoCircularContainment(responseTime, diagnostics, context)) return false;
		boolean result = validate_EveryMultiplicityConforms(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryDataValueConforms(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryReferenceIsContained(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryBidirectionalReferenceIsPaired(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryProxyResolves(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_UniqueID(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryKeyUnique(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validate_EveryMapEntryUnique(responseTime, diagnostics, context);
		if (result || diagnostics != null) result &= validateResponseTime_EnforceExplicitDescriptionWhenExplicitCharacterizationType(responseTime, diagnostics, context);
		return result;
	}

	/**
	 * The cached validation expression for the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Response Time</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static final String RESPONSE_TIME__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION = "\n" +
		"\t\t\tself.characterization = parameterdependencies::RelationshipCharacterizationType::EXPLICIT implies explicitDescription <> null";

	/**
	 * Validates the EnforceExplicitDescriptionWhenExplicitCharacterizationType constraint of '<em>Response Time</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean validateResponseTime_EnforceExplicitDescriptionWhenExplicitCharacterizationType(ResponseTime responseTime, DiagnosticChain diagnostics, Map<Object, Object> context) {
		return
			validate
				(ServicebehaviorPackage.Literals.RESPONSE_TIME,
				 responseTime,
				 diagnostics,
				 context,
				 "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
				 "EnforceExplicitDescriptionWhenExplicitCharacterizationType",
				 RESPONSE_TIME__ENFORCE_EXPLICIT_DESCRIPTION_WHEN_EXPLICIT_CHARACTERIZATION_TYPE__EEXPRESSION,
				 Diagnostic.ERROR,
				 DIAGNOSTIC_SOURCE,
				 0);
	}

	/**
	 * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public ResourceLocator getResourceLocator() {
		// TODO
		// Specialize this to return a resource locator for messages specific to this validator.
		// Ensure that you remove @generated or mark it @generated NOT
		return super.getResourceLocator();
	}

} //ServicebehaviorValidator
