/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.resourcelandscape.impl;

import edu.kit.ipd.descartes.mm.resourcelandscape.Container;
import edu.kit.ipd.descartes.mm.resourcelandscape.ResourcelandscapePackage;
import edu.kit.ipd.descartes.mm.resourcelandscape.RuntimeEnvironment;

import edu.kit.ipd.descartes.mm.runtimeenvironmentclasses.RuntimeEnvironmentClasses;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Runtime Environment</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.RuntimeEnvironmentImpl#getContainedIn <em>Contained In</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.resourcelandscape.impl.RuntimeEnvironmentImpl#getOfClass <em>Of Class</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RuntimeEnvironmentImpl extends ContainerImpl implements RuntimeEnvironment {
	/**
     * The default value of the '{@link #getOfClass() <em>Of Class</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getOfClass()
     * @generated
     * @ordered
     */
	protected static final RuntimeEnvironmentClasses OF_CLASS_EDEFAULT = RuntimeEnvironmentClasses.HYPERVISOR;

	/**
     * The cached value of the '{@link #getOfClass() <em>Of Class</em>}' attribute.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #getOfClass()
     * @generated
     * @ordered
     */
	protected RuntimeEnvironmentClasses ofClass = OF_CLASS_EDEFAULT;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	protected RuntimeEnvironmentImpl() {
        super();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	protected EClass eStaticClass() {
        return ResourcelandscapePackage.Literals.RUNTIME_ENVIRONMENT;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public Container getContainedIn() {
        if (eContainerFeatureID() != ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN) return null;
        return (Container)eContainer();
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public NotificationChain basicSetContainedIn(Container newContainedIn, NotificationChain msgs) {
        msgs = eBasicSetContainer((InternalEObject)newContainedIn, ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN, msgs);
        return msgs;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setContainedIn(Container newContainedIn) {
        if (newContainedIn != eInternalContainer() || (eContainerFeatureID() != ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN && newContainedIn != null)) {
            if (EcoreUtil.isAncestor(this, newContainedIn))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString());
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newContainedIn != null)
                msgs = ((InternalEObject)newContainedIn).eInverseAdd(this, ResourcelandscapePackage.CONTAINER__CONTAINS, Container.class, msgs);
            msgs = basicSetContainedIn(newContainedIn, msgs);
            if (msgs != null) msgs.dispatch();
        }
        else if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN, newContainedIn, newContainedIn));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public RuntimeEnvironmentClasses getOfClass() {
        return ofClass;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public void setOfClass(RuntimeEnvironmentClasses newOfClass) {
        RuntimeEnvironmentClasses oldOfClass = ofClass;
        ofClass = newOfClass == null ? OF_CLASS_EDEFAULT : newOfClass;
        if (eNotificationRequired())
            eNotify(new ENotificationImpl(this, Notification.SET, ResourcelandscapePackage.RUNTIME_ENVIRONMENT__OF_CLASS, oldOfClass, ofClass));
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetContainedIn((Container)otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                return basicSetContainedIn(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                return eInternalContainer().eInverseRemove(this, ResourcelandscapePackage.CONTAINER__CONTAINS, Container.class, msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                return getContainedIn();
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__OF_CLASS:
                return getOfClass();
        }
        return super.eGet(featureID, resolve, coreType);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                setContainedIn((Container)newValue);
                return;
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__OF_CLASS:
                setOfClass((RuntimeEnvironmentClasses)newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public void eUnset(int featureID) {
        switch (featureID) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                setContainedIn((Container)null);
                return;
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__OF_CLASS:
                setOfClass(OF_CLASS_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public boolean eIsSet(int featureID) {
        switch (featureID) {
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__CONTAINED_IN:
                return getContainedIn() != null;
            case ResourcelandscapePackage.RUNTIME_ENVIRONMENT__OF_CLASS:
                return ofClass != OF_CLASS_EDEFAULT;
        }
        return super.eIsSet(featureID);
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        if (eIsProxy()) return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (ofClass: ");
        result.append(ofClass);
        result.append(')');
        return result.toString();
    }

} //RuntimeEnvironmentImpl
