/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.RandomVariable;

import edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Loop User Action</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.LoopUserActionImpl#getLoopBodyScenarioBehavior <em>Loop Body Scenario Behavior</em>}</li>
 *   <li>{@link edu.kit.ipd.descartes.mm.usageprofile.impl.LoopUserActionImpl#getLoopIterationCount <em>Loop Iteration Count</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class LoopUserActionImpl extends AbstractUserActionImpl implements LoopUserAction {
	/**
	 * The cached value of the '{@link #getLoopBodyScenarioBehavior() <em>Loop Body Scenario Behavior</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLoopBodyScenarioBehavior()
	 * @generated
	 * @ordered
	 */
	protected ScenarioBehavior loopBodyScenarioBehavior;

	/**
	 * The cached value of the '{@link #getLoopIterationCount() <em>Loop Iteration Count</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLoopIterationCount()
	 * @generated
	 * @ordered
	 */
	protected RandomVariable loopIterationCount;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LoopUserActionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return UsageProfilePackage.Literals.LOOP_USER_ACTION;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ScenarioBehavior getLoopBodyScenarioBehavior() {
		return loopBodyScenarioBehavior;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLoopBodyScenarioBehavior(ScenarioBehavior newLoopBodyScenarioBehavior, NotificationChain msgs) {
		ScenarioBehavior oldLoopBodyScenarioBehavior = loopBodyScenarioBehavior;
		loopBodyScenarioBehavior = newLoopBodyScenarioBehavior;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR, oldLoopBodyScenarioBehavior, newLoopBodyScenarioBehavior);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLoopBodyScenarioBehavior(ScenarioBehavior newLoopBodyScenarioBehavior) {
		if (newLoopBodyScenarioBehavior != loopBodyScenarioBehavior) {
			NotificationChain msgs = null;
			if (loopBodyScenarioBehavior != null)
				msgs = ((InternalEObject)loopBodyScenarioBehavior).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR, null, msgs);
			if (newLoopBodyScenarioBehavior != null)
				msgs = ((InternalEObject)newLoopBodyScenarioBehavior).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR, null, msgs);
			msgs = basicSetLoopBodyScenarioBehavior(newLoopBodyScenarioBehavior, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR, newLoopBodyScenarioBehavior, newLoopBodyScenarioBehavior));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RandomVariable getLoopIterationCount() {
		return loopIterationCount;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetLoopIterationCount(RandomVariable newLoopIterationCount, NotificationChain msgs) {
		RandomVariable oldLoopIterationCount = loopIterationCount;
		loopIterationCount = newLoopIterationCount;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT, oldLoopIterationCount, newLoopIterationCount);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLoopIterationCount(RandomVariable newLoopIterationCount) {
		if (newLoopIterationCount != loopIterationCount) {
			NotificationChain msgs = null;
			if (loopIterationCount != null)
				msgs = ((InternalEObject)loopIterationCount).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT, null, msgs);
			if (newLoopIterationCount != null)
				msgs = ((InternalEObject)newLoopIterationCount).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT, null, msgs);
			msgs = basicSetLoopIterationCount(newLoopIterationCount, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT, newLoopIterationCount, newLoopIterationCount));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR:
				return basicSetLoopBodyScenarioBehavior(null, msgs);
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT:
				return basicSetLoopIterationCount(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR:
				return getLoopBodyScenarioBehavior();
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT:
				return getLoopIterationCount();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR:
				setLoopBodyScenarioBehavior((ScenarioBehavior)newValue);
				return;
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT:
				setLoopIterationCount((RandomVariable)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR:
				setLoopBodyScenarioBehavior((ScenarioBehavior)null);
				return;
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT:
				setLoopIterationCount((RandomVariable)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR:
				return loopBodyScenarioBehavior != null;
			case UsageProfilePackage.LOOP_USER_ACTION__LOOP_ITERATION_COUNT:
				return loopIterationCount != null;
		}
		return super.eIsSet(featureID);
	}

} //LoopUserActionImpl
