/**
 * Copyright 2009-2012, Descartes Research Group, SDQ, IPD, KIT
 */
package edu.kit.ipd.descartes.mm.usageprofile.impl;

import edu.kit.ipd.descartes.core.CorePackage;

import edu.kit.ipd.descartes.mm.applicationlevel.functions.FunctionsPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.parameterdependencies.ParameterdependenciesPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.repository.RepositoryPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.servicebehavior.ServicebehaviorPackage;

import edu.kit.ipd.descartes.mm.applicationlevel.system.SystemPackage;

import edu.kit.ipd.descartes.mm.usageprofile.AbstractUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.BranchUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.CallParameterSetting;
import edu.kit.ipd.descartes.mm.usageprofile.ClosedWorkloadType;
import edu.kit.ipd.descartes.mm.usageprofile.DelayUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.Import;
import edu.kit.ipd.descartes.mm.usageprofile.LoopUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.OpenWorkloadType;
import edu.kit.ipd.descartes.mm.usageprofile.ScenarioBehavior;
import edu.kit.ipd.descartes.mm.usageprofile.SystemCallUserAction;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfile;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfileFactory;
import edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage;
import edu.kit.ipd.descartes.mm.usageprofile.UsageScenario;
import edu.kit.ipd.descartes.mm.usageprofile.WorkloadType;

import edu.kit.ipd.descartes.mm.usageprofile.util.UsageProfileValidator;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class UsageProfilePackageImpl extends EPackageImpl implements UsageProfilePackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass usageProfileEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass usageScenarioEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scenarioBehaviorEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass workloadTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass importEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass openWorkloadTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass closedWorkloadTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass abstractUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass loopUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass delayUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass branchUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass systemCallUserActionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass callParameterSettingEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see edu.kit.ipd.descartes.mm.usageprofile.UsageProfilePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private UsageProfilePackageImpl() {
		super(eNS_URI, UsageProfileFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link UsageProfilePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static UsageProfilePackage init() {
		if (isInited) return (UsageProfilePackage)EPackage.Registry.INSTANCE.getEPackage(UsageProfilePackage.eNS_URI);

		// Obtain or create and register package
		UsageProfilePackageImpl theUsageProfilePackage = (UsageProfilePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof UsageProfilePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new UsageProfilePackageImpl());

		isInited = true;

		// Initialize simple dependencies
		FunctionsPackage.eINSTANCE.eClass();
		ParameterdependenciesPackage.eINSTANCE.eClass();
		RepositoryPackage.eINSTANCE.eClass();
		ServicebehaviorPackage.eINSTANCE.eClass();
		SystemPackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theUsageProfilePackage.createPackageContents();

		// Initialize created meta-data
		theUsageProfilePackage.initializePackageContents();

		// Register package validator
		EValidator.Registry.INSTANCE.put
			(theUsageProfilePackage, 
			 new EValidator.Descriptor() {
				 public EValidator getEValidator() {
					 return UsageProfileValidator.INSTANCE;
				 }
			 });

		// Mark meta-data to indicate it can't be changed
		theUsageProfilePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(UsageProfilePackage.eNS_URI, theUsageProfilePackage);
		return theUsageProfilePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUsageProfile() {
		return usageProfileEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageProfile_Imports() {
		return (EReference)usageProfileEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageProfile_System() {
		return (EReference)usageProfileEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageProfile_UsageScenarios() {
		return (EReference)usageProfileEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUsageScenario() {
		return usageScenarioEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageScenario_UsageModel() {
		return (EReference)usageScenarioEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageScenario_ScenarioBehavior() {
		return (EReference)usageScenarioEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUsageScenario_WorkloadType() {
		return (EReference)usageScenarioEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScenarioBehavior() {
		return scenarioBehaviorEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScenarioBehavior_Actions() {
		return (EReference)scenarioBehaviorEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getWorkloadType() {
		return workloadTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getWorkloadType_UsageScenario() {
		return (EReference)workloadTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getImport() {
		return importEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getImport_ImportURI() {
		return (EAttribute)importEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getImport_Usageprofile() {
		return (EReference)importEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOpenWorkloadType() {
		return openWorkloadTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getOpenWorkloadType_InterArrivalTime() {
		return (EReference)openWorkloadTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getClosedWorkloadType() {
		return closedWorkloadTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getClosedWorkloadType_Population() {
		return (EAttribute)closedWorkloadTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getClosedWorkloadType_ThinkTime() {
		return (EReference)closedWorkloadTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAbstractUserAction() {
		return abstractUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAbstractUserAction_ParentScenarioBehavior() {
		return (EReference)abstractUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLoopUserAction() {
		return loopUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopUserAction_LoopBodyScenarioBehavior() {
		return (EReference)loopUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLoopUserAction_LoopIterationCount() {
		return (EReference)loopUserActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDelayUserAction() {
		return delayUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDelayUserAction_Delay() {
		return (EReference)delayUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getBranchUserAction() {
		return branchUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchUserAction_Branches() {
		return (EReference)branchUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getBranchUserAction_BranchingProbabilities() {
		return (EReference)branchUserActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSystemCallUserAction() {
		return systemCallUserActionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSystemCallUserAction_ProvidingRole() {
		return (EReference)systemCallUserActionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSystemCallUserAction_Signature() {
		return (EReference)systemCallUserActionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSystemCallUserAction_InputParameterSettings() {
		return (EReference)systemCallUserActionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCallParameterSetting() {
		return callParameterSettingEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCallParameterSetting_Name() {
		return (EAttribute)callParameterSettingEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCallParameterSetting_Characterization() {
		return (EAttribute)callParameterSettingEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCallParameterSetting_Value() {
		return (EReference)callParameterSettingEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UsageProfileFactory getUsageProfileFactory() {
		return (UsageProfileFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		usageProfileEClass = createEClass(USAGE_PROFILE);
		createEReference(usageProfileEClass, USAGE_PROFILE__IMPORTS);
		createEReference(usageProfileEClass, USAGE_PROFILE__SYSTEM);
		createEReference(usageProfileEClass, USAGE_PROFILE__USAGE_SCENARIOS);

		usageScenarioEClass = createEClass(USAGE_SCENARIO);
		createEReference(usageScenarioEClass, USAGE_SCENARIO__USAGE_MODEL);
		createEReference(usageScenarioEClass, USAGE_SCENARIO__SCENARIO_BEHAVIOR);
		createEReference(usageScenarioEClass, USAGE_SCENARIO__WORKLOAD_TYPE);

		scenarioBehaviorEClass = createEClass(SCENARIO_BEHAVIOR);
		createEReference(scenarioBehaviorEClass, SCENARIO_BEHAVIOR__ACTIONS);

		workloadTypeEClass = createEClass(WORKLOAD_TYPE);
		createEReference(workloadTypeEClass, WORKLOAD_TYPE__USAGE_SCENARIO);

		importEClass = createEClass(IMPORT);
		createEAttribute(importEClass, IMPORT__IMPORT_URI);
		createEReference(importEClass, IMPORT__USAGEPROFILE);

		openWorkloadTypeEClass = createEClass(OPEN_WORKLOAD_TYPE);
		createEReference(openWorkloadTypeEClass, OPEN_WORKLOAD_TYPE__INTER_ARRIVAL_TIME);

		closedWorkloadTypeEClass = createEClass(CLOSED_WORKLOAD_TYPE);
		createEAttribute(closedWorkloadTypeEClass, CLOSED_WORKLOAD_TYPE__POPULATION);
		createEReference(closedWorkloadTypeEClass, CLOSED_WORKLOAD_TYPE__THINK_TIME);

		abstractUserActionEClass = createEClass(ABSTRACT_USER_ACTION);
		createEReference(abstractUserActionEClass, ABSTRACT_USER_ACTION__PARENT_SCENARIO_BEHAVIOR);

		loopUserActionEClass = createEClass(LOOP_USER_ACTION);
		createEReference(loopUserActionEClass, LOOP_USER_ACTION__LOOP_BODY_SCENARIO_BEHAVIOR);
		createEReference(loopUserActionEClass, LOOP_USER_ACTION__LOOP_ITERATION_COUNT);

		delayUserActionEClass = createEClass(DELAY_USER_ACTION);
		createEReference(delayUserActionEClass, DELAY_USER_ACTION__DELAY);

		branchUserActionEClass = createEClass(BRANCH_USER_ACTION);
		createEReference(branchUserActionEClass, BRANCH_USER_ACTION__BRANCHES);
		createEReference(branchUserActionEClass, BRANCH_USER_ACTION__BRANCHING_PROBABILITIES);

		systemCallUserActionEClass = createEClass(SYSTEM_CALL_USER_ACTION);
		createEReference(systemCallUserActionEClass, SYSTEM_CALL_USER_ACTION__PROVIDING_ROLE);
		createEReference(systemCallUserActionEClass, SYSTEM_CALL_USER_ACTION__SIGNATURE);
		createEReference(systemCallUserActionEClass, SYSTEM_CALL_USER_ACTION__INPUT_PARAMETER_SETTINGS);

		callParameterSettingEClass = createEClass(CALL_PARAMETER_SETTING);
		createEAttribute(callParameterSettingEClass, CALL_PARAMETER_SETTING__NAME);
		createEAttribute(callParameterSettingEClass, CALL_PARAMETER_SETTING__CHARACTERIZATION);
		createEReference(callParameterSettingEClass, CALL_PARAMETER_SETTING__VALUE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		CorePackage theCorePackage = (CorePackage)EPackage.Registry.INSTANCE.getEPackage(CorePackage.eNS_URI);
		SystemPackage theSystemPackage = (SystemPackage)EPackage.Registry.INSTANCE.getEPackage(SystemPackage.eNS_URI);
		FunctionsPackage theFunctionsPackage = (FunctionsPackage)EPackage.Registry.INSTANCE.getEPackage(FunctionsPackage.eNS_URI);
		RepositoryPackage theRepositoryPackage = (RepositoryPackage)EPackage.Registry.INSTANCE.getEPackage(RepositoryPackage.eNS_URI);
		ParameterdependenciesPackage theParameterdependenciesPackage = (ParameterdependenciesPackage)EPackage.Registry.INSTANCE.getEPackage(ParameterdependenciesPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		usageProfileEClass.getESuperTypes().add(theCorePackage.getEntity());
		usageScenarioEClass.getESuperTypes().add(theCorePackage.getEntity());
		openWorkloadTypeEClass.getESuperTypes().add(this.getWorkloadType());
		closedWorkloadTypeEClass.getESuperTypes().add(this.getWorkloadType());
		loopUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());
		delayUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());
		branchUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());
		systemCallUserActionEClass.getESuperTypes().add(this.getAbstractUserAction());

		// Initialize classes and features; add operations and parameters
		initEClass(usageProfileEClass, UsageProfile.class, "UsageProfile", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUsageProfile_Imports(), this.getImport(), this.getImport_Usageprofile(), "imports", null, 0, -1, UsageProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
		initEReference(getUsageProfile_System(), theSystemPackage.getSystem(), null, "system", null, 0, 1, UsageProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUsageProfile_UsageScenarios(), this.getUsageScenario(), this.getUsageScenario_UsageModel(), "usageScenarios", null, 0, -1, UsageProfile.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(usageScenarioEClass, UsageScenario.class, "UsageScenario", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUsageScenario_UsageModel(), this.getUsageProfile(), this.getUsageProfile_UsageScenarios(), "usageModel", null, 1, 1, UsageScenario.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUsageScenario_ScenarioBehavior(), this.getScenarioBehavior(), null, "scenarioBehavior", null, 1, 1, UsageScenario.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUsageScenario_WorkloadType(), this.getWorkloadType(), this.getWorkloadType_UsageScenario(), "workloadType", null, 1, 1, UsageScenario.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(scenarioBehaviorEClass, ScenarioBehavior.class, "ScenarioBehavior", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getScenarioBehavior_Actions(), this.getAbstractUserAction(), this.getAbstractUserAction_ParentScenarioBehavior(), "actions", null, 0, -1, ScenarioBehavior.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(workloadTypeEClass, WorkloadType.class, "WorkloadType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getWorkloadType_UsageScenario(), this.getUsageScenario(), this.getUsageScenario_WorkloadType(), "usageScenario", null, 1, 1, WorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(importEClass, Import.class, "Import", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getImport_ImportURI(), ecorePackage.getEString(), "importURI", null, 0, 1, Import.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getImport_Usageprofile(), this.getUsageProfile(), this.getUsageProfile_Imports(), "usageprofile", null, 1, 1, Import.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(openWorkloadTypeEClass, OpenWorkloadType.class, "OpenWorkloadType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getOpenWorkloadType_InterArrivalTime(), theFunctionsPackage.getRandomVariable(), null, "interArrivalTime", null, 1, 1, OpenWorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(closedWorkloadTypeEClass, ClosedWorkloadType.class, "ClosedWorkloadType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getClosedWorkloadType_Population(), ecorePackage.getEBigInteger(), "population", null, 1, 1, ClosedWorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getClosedWorkloadType_ThinkTime(), theFunctionsPackage.getRandomVariable(), null, "thinkTime", null, 1, 1, ClosedWorkloadType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(abstractUserActionEClass, AbstractUserAction.class, "AbstractUserAction", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAbstractUserAction_ParentScenarioBehavior(), this.getScenarioBehavior(), this.getScenarioBehavior_Actions(), "parentScenarioBehavior", null, 1, 1, AbstractUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(loopUserActionEClass, LoopUserAction.class, "LoopUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getLoopUserAction_LoopBodyScenarioBehavior(), this.getScenarioBehavior(), null, "loopBodyScenarioBehavior", null, 1, 1, LoopUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getLoopUserAction_LoopIterationCount(), theFunctionsPackage.getRandomVariable(), null, "loopIterationCount", null, 1, 1, LoopUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(delayUserActionEClass, DelayUserAction.class, "DelayUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDelayUserAction_Delay(), theFunctionsPackage.getRandomVariable(), null, "delay", null, 1, 1, DelayUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(branchUserActionEClass, BranchUserAction.class, "BranchUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getBranchUserAction_Branches(), this.getScenarioBehavior(), null, "branches", null, 0, -1, BranchUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getBranchUserAction_BranchingProbabilities(), theFunctionsPackage.getRandomVariable(), null, "branchingProbabilities", null, 1, 1, BranchUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(systemCallUserActionEClass, SystemCallUserAction.class, "SystemCallUserAction", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSystemCallUserAction_ProvidingRole(), theRepositoryPackage.getInterfaceProvidingRole(), null, "providingRole", null, 1, 1, SystemCallUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSystemCallUserAction_Signature(), theRepositoryPackage.getSignature(), null, "signature", null, 1, 1, SystemCallUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSystemCallUserAction_InputParameterSettings(), this.getCallParameterSetting(), null, "inputParameterSettings", null, 0, -1, SystemCallUserAction.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

		initEClass(callParameterSettingEClass, CallParameterSetting.class, "CallParameterSetting", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCallParameterSetting_Name(), ecorePackage.getEString(), "name", null, 1, 1, CallParameterSetting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCallParameterSetting_Characterization(), theParameterdependenciesPackage.getParameterCharacterizationType(), "characterization", "VALUE", 1, 1, CallParameterSetting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCallParameterSetting_Value(), theFunctionsPackage.getRandomVariable(), null, "value", null, 1, 1, CallParameterSetting.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http://www.eclipse.org/OCL/Import
		createImportAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore
		createEcoreAnnotations();
		// http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot
		createPivotAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/OCL/Import</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createImportAnnotations() {
		String source = "http://www.eclipse.org/OCL/Import";	
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "core_0", "../../edu.kit.ipd.descartes.core/model/core.ecore#/",
			 "ecore_0", "http://www.eclipse.org/emf/2002/Ecore",
			 "functions_0", "../../edu.kit.ipd.descartes.mm.applicationlevel/model/functions.ecore#/",
			 "parameterdependency_0", "../../edu.kit.ipd.descartes.mm.applicationlevel/model/parameterdependency.ecore#/",
			 "repository_0", "../../edu.kit.ipd.descartes.mm.applicationlevel/model/repository.ecore#/",
			 "system_0", "../../edu.kit.ipd.descartes.mm.applicationlevel/model/system.ecore#/"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createEcoreAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore";	
		addAnnotation
		  (this, 
		   source, 
		   new String[] {
			 "invocationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "settingDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot",
			 "validationDelegates", "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"
		   });	
		addAnnotation
		  (openWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "constraints", "interArrivalTimeInOpenWorkloadNeedsToBeSpecified"
		   });	
		addAnnotation
		  (closedWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "constraints", "thinkTimeInClosedWorkloadNeedsToBeSpecified populationInClosedWorkloadNeedsToBeGreaterThanZero"
		   });
	}

	/**
	 * Initializes the annotations for <b>http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createPivotAnnotations() {
		String source = "http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot";	
		addAnnotation
		  (openWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "interArrivalTimeInOpenWorkloadNeedsToBeSpecified", "\n\t\t\t          not self.interArrivalTime.oclIsUndefined() and not self.interArrivalTime.probFunction.oclIsUndefined()"
		   });	
		addAnnotation
		  (closedWorkloadTypeEClass, 
		   source, 
		   new String[] {
			 "thinkTimeInClosedWorkloadNeedsToBeSpecified", "\n\t\t\t            not self.thinkTime.oclIsUndefined() and not self.thinkTime.probFunction.oclIsUndefined()",
			 "populationInClosedWorkloadNeedsToBeGreaterThanZero", "\n\t\t\t \t\t    self.population > 0"
		   });
	}

} //UsageProfilePackageImpl
